include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext MonoPattern, ColorPattern, SpritePattern
ext VVram_

VramTop equ Vram+VramRowSize*0

GDC equ 100h
WDC equ 110h
VDC2 equ 120h
VDC1 equ 130h

CharSize equ CharHeight*PlaneCount*2
SpriteSize equ CharHeight*2*2*(PlaneCount+1)*2
MidVSeg equ 1000h
MidPlaneSize equ 4000h
CharRam equ MidPlaneSize*PlaneCount
SpriteRam equ CharRam+CharSize*Char_End
MidFlags equ SpriteRam+SpriteSize*Pattern_End

dseg
Backup:
	defs VVramWidth*VVramHeight
color:
	defb 0


cseg
InitVram: public InitVram
    ; mov bx,80*8*10/2
    ; mov dx,WDC
    ; mov al,1
    ; out dx,al
    ; mov dx,WDC+2
    ; mov al,bl | out dx,al
    ; mov al,bh | out dx,al

    mov dx,VDC2
    xor al,al
    out dx,al
    ; mov dx,VDC1
    ; mov al,04h
    ; out dx,al

    mov ax,MidVSeg | mov es,ax

	mov di,CharRam+CharSize*Char_Ascii
	mov si,MonoPattern+CharHeight*Char_Ascii
	mov cx,(7 shl 8) or (Char_Logo-Char_Ascii)
	call MakePatternMono

    mov di,CharRam+CharSize*Char_Logo
	mov si,MonoPattern+CharHeight*Char_Logo
	mov cx,(6 shl 8) or (Char_CrackedFloor-Char_Logo)
	call MakePatternMono

    mov di,CharRam+CharSize*Char_CrackedFloor
	mov si,MonoPattern+CharHeight*Char_CrackedFloor
	mov cx,(5 shl 8) or (Char_Ladder-Char_CrackedFloor)
	call MakePatternMono

    mov di,CharRam+CharSize*Char_Ladder
	mov si,MonoPattern+CharHeight*Char_Ladder
	mov cx,(6 shl 8) or (Char_Remain-Char_Ladder)
	call MakePatternMono

    mov di,CharRam+CharSize*Char_Remain
	mov si,ColorPattern
	mov cl,Char_End-Char_Remain
	call MakePatternColor

	mov di,SpriteRam
	mov si,SpritePattern
	mov cl,Pattern_End
	call MakeSpritePattern
ret

DoubleBits:
	push cx
		xor dx,dx
		mov ch,8
		do
			shl dx | shl dx
			shr al,1
			if b
				or dx,0003h
			endif
			dec ch
		while ne | wend
	pop cx
ret

MakePatternMono:
	mov [color],ch
	do
		mov ch,CharHeight
		do
			push cx
				mov al,[si] | inc si
				call DoubleBits
				xchg dl,dh
				mov al,[color]
				mov cl,PlaneCount
				do
					xor bx,bx
					test al,01h
					if nz
						or bx,dx
					endif
					test al,10h
					if nz
						not dx
						or bx,dx
						not dx
					endif
					mov [es:di],bx
					shr al,1
					add di,CharHeight*2
					dec cl
				while nz | wend
				add di,2-CharHeight*2*PlaneCount
			pop cx
			dec ch
		while nz | wend
		add di,CharHeight*2*2
		dec cl
	while nz | wend
ret

MakePatternColor:
	do
		mov ch,CharHeight*PlaneCount
		do
			mov al,[si] | inc si
			call DoubleBits
			xchg dl,dh
			mov [es:di],dx
			add di,2
			dec ch
		while nz | wend
		dec cl
	while nz | wend
ret

MakeSpritePattern: public MakeSpritePattern
	do
		mov ch,128
		do
			mov ax,[si]
            inc si
            call DoubleBits
			mov [es:di],dx
            inc di | inc di
			dec ch
		while nz | wend
		dec cl
	while nz | wend
ret


; void PresentVram();
cseg
PresentVram_: public PresentVram_
    push ax | push cx | push dx | push bx | push si | push di
    push ds
        mov ax,MidVSeg | mov ds,ax
        mov si,Vram
        mov di,0
        mov bx,MidFlags
        mov ch,VramHeight
        do
            mov cl,VramWidth/VramStep
            do
                cmp byte ptr[bx],0
                if nz
                    mov ax,0c000h | mov es,ax
                    do
                        mov dl,CharHeight
                        do
                            mov ax,[si]
                            add si,VramWidth
                            mov word ptr [es:di],ax
                            mov word ptr [es:di+VramWidth],ax
                            add di,VramWidth*2
                            dec dl
                        while nz | wend
                        add si,MidPlaneSize-VramWidth*CharHeight
                        add di,-VramWidth*CharHeight*2
                        mov ax,es
                        add ah,10h
                        mov es,ax
                        cmp ah,0f0h
                    while nz | wend
                    add si,-MidPlaneSize*PlaneCount
                    mov byte ptr[bx],0
                endif
                inc si | inc si
                inc di | inc di
                inc bx
                dec cl
            while nz | wend
            add si,VramWidth*(CharHeight-1)
            add di,VramWidth*(CharHeight*2-1)
            dec ch
        while nz | wend
    pop ds
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret


; void ClearScreen();
cseg
ClearScreen_:  public ClearScreen_
	push ax | push cx | push dx | push bx
		xor dx,dx

		mov bx,backup
		mov cx,VVramWidth*VVramHeight/2
		do
			mov [bx],dx
			inc bx | inc bx
		wloop

        mov ax,0c000h
        do
            mov es,ax
            mov bx,0
            mov cx,8000h/2
            do
                mov [es:bx],dx
    			inc bx | inc bx
            wloop
            mov ax,es
            add ah,10h
            cmp ah,0f0h
        while nz | wend

        mov ax,MidVSeg | mov es,ax
		mov bx,Vram
		mov cx,MidPlaneSize*PlaneCount/2
		do
			mov [es:bx],dx
			inc bx | inc bx
		wloop
        
        mov bx,MidFlags
        mov cx,VramWidth*VramHeight/VramStep/2
        do
			mov [es:bx],dx
			inc bx | inc bx
		wloop
	pop bx | pop dx | pop cx | pop ax
ret


cseg
Put1:
; in
;   al: char
;   di: vram address
    push cx | push di
        mov ah,CharSize | mul ah
        add ax,CharRam
        mov si,ax

        mov ch,PlaneCount
        do
            mov cl,CharHeight
            do
                mov ax,[si]
                inc si | inc si
                xchg ah,al
                mov [di],ax
                add di,VramWidth
                dec cl
            while ne | wend
            add di,MidPlaneSize-VramWidth*CharHeight
            dec ch
        while ne | wend
    pop di | pop cx
ret


; void Put(word vram, byte c);
cseg
Put_: public Put_
	push ax | push bx | push dx | push si | push di
    push ds
        mov bx,MidVSeg | mov ds,bx

        push ax
            mov di,ax
            mov al,dl
            call Put1
        pop ax
        
        xor dx,dx
        mov bx,VramRowSize
        div bx
        mov bl,VramWidth/2
        mul bl
        mov bx,MidFlags
        add bx,ax
        shr dx,1
        add bx,dx
        mov byte ptr [bx],0ffh
    pop ds
	pop di | pop si | pop dx | pop bx | pop ax
	inc ax | inc ax
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
	push ax | push cx | push dx | push bx | push si | push di
        mov dx,MidFlags
		mov bx,VVram_
		mov si,Backup
		mov di,VramTop
		mov ch, VVramHeight ; vertical count
		do
			mov cl,VVramWidth
			do 
				mov al,[bx]
				inc bx
				cmp al,[si]
				if ne
					mov [si],al
					push si
                    push ds
                        mov si,MidVSeg | mov ds,si
						call Put1
                        mov al,0ffh
                        mov si,dx
                        mov [si],al
                    pop ds
					pop si
				endif
				inc di | inc di
				inc si
                inc dx
				dec cl
			while nz | wend
			add di,VramRowSize-VVramWidth*VramStep
            add dx,VramWidth/2-VVramWidth
			dec ch
		while nz | wend
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret


; void EraseBackup(byte x, byte y);
cseg
EraseBackup_: public EraseBackup_
	push ax | push dx | push cx | push bx
		mov cx,0202h
		test al,1
		if nz
			inc ch
		endif
		shr al,1
		mov bl,al
		xor bh,bh
		
		test dl,1
		if nz
			inc cl
		endif
		shr dl,1

		mov al,VVramWidth
		mul dl
		add ax,bx
		add ax,Backup
		mov bx,ax

		mov al,0ffh
		do
			push bx
				mov ah,ch
				do
					mov [bx],al
					inc bx
					dec ah
				while nz | wend
			pop bx
			add bx,VVramWidth
			dec cl
		while nz | wend
 	pop bx | pop cx | pop dx | pop ax
ret


; void DrawSprite(byte x, byte y, byte pattern);
cseg
DrawSprite_: public DrawSprite_
	push ax | push cx | push dx | push bx | push si | push di
    push ds
        mov bl,al
		xchg al,dl
		mov ch,VramWidth/4
		mul ch
        push ax
            add ax,ax
            add ax,ax
            add ax,ax
            add ax,ax
            xor dh,dh
            add ax,dx
            add ax,VramTop
            mov di,ax

            mov ah,cl
            xor al,al
            add ax,SpriteRam
            mov si,ax

            mov ax,MidVSeg | mov ds,ax
            mov cl,bl
            mov ch,CharHeight*2
            do
                push cx
                    mov ch,4/2
                    do
                        mov bx,[si]
                        inc si | inc si
                        not bx
                        mov cl,PlaneCount
                        do
                            mov dx,[si]
                            inc si | inc si

                            mov ax,[di]
                            and ax,bx
                            or ax,dx
                            mov [di],ax
                            add di,MidPlaneSize
                            
                            dec cl
                        while nz | wend
                        add di,2-MidPlaneSize*PlaneCount
                        dec ch
                    while nz | wend
                    add di,VramWidth-4
                pop cx
                dec ch
            while nz | wend
        pop ax
        mov bx,MidFlags
        add bx,ax
        shr cl,1
        xor ch,ch
        add bx,cx
        mov al,0ffh
        mov ch,2
        do
            mov cl,2
            do
                mov [bx],al | inc bx
                dec cl
            while nz | wend
            add bx,VramWidth/2-2
            dec ch
        while nz | wend
    pop ds
	pop di | pop si | pop bx | pop cx | pop dx | pop ax
ret
